#ifndef DATA_H_
#define DATA_H_

#include "common.h"
#include "xmlloadmodel.h"

/**
 * Read various matrices from an xml file
 *
 * Return three matrices:
 * 1st - .first.first  - cluster_means
 * 2nd - .first.second - cov_matrix
 * 3rd - .second       - cluster_means_norm
 */
IMPEXP
std::pair< std::pair<CvMat*, CvMat*>, CvMat*> ReadTextons(std::string const & texton_xml_file);


#endif
