#if !defined ILCHARSEGMENT
#define ILCHARSEGMENT

#include <stdio.h>
#include <math.h>
#include <string.h>
using std::string;

#include "cv.h"      // include core library interface
#include "cxcore.h"   
#include "highgui.h" // include GUI library interface

/* Include the MCR header file and the library specific header file 
 * as generated by MATLAB Compiler */
#include "mclmcr.h" 
#include "libnncharrec.h"

int ilNPCharRead(const CvArr *srcarr, string *npstr, int thr0=60, int thrstep=10, int nthr=10, CvMat **charrectout=NULL);
int ilNPCharReadAtThresh(const CvArr *srcarr, string *npstr, CvMat **npcharrect, int graythresh);
int ilNPCharRead(const CvArr *srcarr, string *npstr, CvMat **npcharrect, int graythresh);
void ilCharLineSegment(const CvArr *src, CvSeq *dst, int *rectnumout, int graythreshval);
void ilCharRecognize(CvArr *src, CvSeq *rectseq, string *npstrout, int rectnum, int graythreshval);
// void ilCharRecognize(CvArr *src, CvSeq *rectseq, char *npcharout, int rectnum);
int ilCharLineRANSAC(double *rectarr, int *flagacc, int cnum, int inum=100);
int ilCharLineRANSACUpdate1(double *rectarr, int *flagacc, int cnum, int inum);
static int ilRectCmpX( const void* _a, const void* _b, void* userdata=0);

#endif