#include "localhistlinclass.h"
#include "localhistintegral.h"
#include "linclass.h"
#include "stdafx.h"

/**
 * Check if the subwindow passes the particular rule from the stage
 * 
 * return true if it passes the test
 */
 #include <iostream>
bool localhistlinclass(StageRule const & rule,
                       CvMat ** integral_block_histogram,
                       uint channels,
                       uint left, uint top,
                       uint width, uint height)
{
    static std::vector<double> feature;
    localhistintegral(rule,                         // <- input
                      integral_block_histogram,     // <- input
                      channels,
                      left, top, width, height,     // <- input
                      feature);                     // <- output

    // use the feature values to check if the subwindow passes the rule test
    return linclass(feature, rule);
}
